#!/src/bin/python
import spidev
import time
import pygame
import pygame.midi
import sys
spi = spidev.SpiDev()
spi.open(0, 1)
spi.max_speed_hz = 524288
pygame.init()
pygame.midi.init()
port = -1

for id in range(pygame.midi.get_count()):
	print pygame.midi.get_device_info(id)
	devapi, devname, devin, devout, devopen = pygame.midi.get_device_info(id)
	if devout == 1 and devname == 'NSX-39 MIDI 1':
		port = id        #NSX-39 Output

if port == -1:
	print 'cannot find NSX-39.'
	sys.exit()

midiOutput = pygame.midi.Output(port, 0, 4096) #tekitou
print 'waiting...'
#-----------------------------------------------------------------
def readbyte():
	while True:
	r = spi.xfer2([0x39])
	if r[0] != 0x93:
		continue
	r = spi.xfer2([0x00])
	return r[0]
#-----------------------------------------------------------------
try:
	while True:
		r = readbyte()
		if r == 0xF0:
			l = [r]
			while True:
				x = readbyte()
				l.append(x)
				if x == 0xF7:
					break
			for ll in range(len(l)):
				print '%02X,' % (l[ll]),
			print '\n'
			midiOutput.write_sys_ex(0, l)
			del l[:]
		else:
			x = readbyte()
			y = readbyte()
			print '%02X, %02X, %02X' % (r, x, y)
			midiOutput.write_short(r, x, y)
except	KeyboardInterrupt:
		time.sleep(0.5) #must wait before quit
		spi.close()
		del midiOutput
		pygame.midi.quit()
		pygamie.quit()
#end
